/*
 * (SLIK) SimpLIstic sKin functions
 * (C) 2003 John Ellis
 *
 * Author: John Ellis
 *
 * This software is released under the GNU General Public License (GNU GPL).
 * Please read the included file COPYING for more information.
 * This software comes with no warranty of any kind, use at your own risk!
 */


#ifndef UI_TREE_EDIT_H
#define UI_TREE_EDIT_H


typedef struct _TreeEditData TreeEditData;
struct _TreeEditData
{
	GtkWidget *window;
	GtkWidget *entry;

	gchar *old_name;
	gchar *new_name;

	gint (*edit_func)(TreeEditData *ced, const gchar *oldname, const gchar *newname, gpointer data);
	gpointer edit_data;

	GtkTreeView *tree;
	GtkTreePath *path;
	GtkTreeViewColumn *column;
};


/*
 * edit_func: return TRUE is rename successful, FALSE on failure.
 */
gint tree_edit_by_path(GtkTreeView *tree, GtkTreePath *tpath, gint column, const gchar *text,
		       gint (*edit_func)(TreeEditData *, const gchar *, const gchar *, gpointer), gpointer data);

#if 0
/*
 * use this when highlighting a right-click menued or dnd clist row.
 */
void tree_edit_set_highlight(GtkTreeView *tree, GtkTreeIter *iter);
#endif

/*
 * Shifts a style's color for given state
 * Useful for alternating dark/light rows in lists.
 *
 * shift_value is 1 to 100, representing the percent of the shift.
 */
void style_shift_color(GtkStyle *style, GtkStateType type, gshort shift_value, gint direction);

/*
 * The standard shift percent for alternating list row colors
 */
#define STYLE_SHIFT_STANDARD 10


#endif

